# encoding: utf-8

require 'forwardable'

module Flow
  module Build
    class Configuration
      extend Forwardable
      def_delegators :@hash, :to_hash, :[], :[]=, :==, :fetch, :delete, :has_key?

      DEFAULTS = {
        env:         'production',
        log:         STDOUT,
        log_level:   Logger::INFO
      }.freeze

      def initialize
        clear
      end

      def clear
        @hash = DEFAULTS.dup
      end

      def merge(hash)
        instance = self.class.new
        @hash.merge!(hash.dup)
        instance
      end
    end
  end
end
