# encoding: utf-8

require_relative './env/builtin'
require_relative './env/var'

module Flow
  module Build
    module Service
      class Env
        include Builtin
        include Var

        attr_reader :custom_envs
        attr_accessor :script

        def initialize(custom_envs = {})
          @custom_envs = custom_envs
          @script = []
        end

        def apply
          add_builtin_envs
          add_custom_envs
          script.join("\n")
        end

        def add_builtin_envs
        end

        def add_custom_envs
          custom_envs.each do |key, value|
            script << "export #{key.upcase}=#{value}"
          end
          script << "\n"
        end
      end
    end
  end
end
