# encoding: utf-8

require_relative './git/clone'
require_relative './git/ssh_key'

module Flow
  module Build
    module Service
      class Git
        include Clone
        include SshKey

        attr_reader :git_url, :ssh_key, :branch, :repo_dir, :repo_name
        attr_accessor :script

        def initialize(options = {})
          @git_url   = options.fetch(:git_url, '')
          @ssh_key   = options.fetch(:ssh_key, '')
          @repo_dir  = options.fetch(:repo_dir, '')
          @repo_name = options.fetch(:repo_name, '')
          @branch    = options.fetch(:branch, 'master')
          @script    = []
        end

        def git_host
          git_url =~ %r(^(?:https?|git)(?:://|@)([^/]*?)(?:/|:)) && $1.split('@').last
        end

        def apply
          install_ssh_key
          git_clone
          script.join("\n")
        end
      end
    end
  end
end
