# encoding: utf-8

module Flow
  module Build
    module Service
      class Parser
        module Ruby
          def ruby_apply(version)
            script = ['source $HOME/.rvm/scripts/rvm']
            script << flow_cmd('rvm -v', echo: true)
            script << flow_cmd('ruby -v', echo: true)
            script << flow_cmd("rvm use #{version} --install --binary --fuzzy", echo: true, assert: true, timing: true)
            script << flow_cmd('gem -v', echo: true)
            script << flow_cmd('gem install bundler rake', echo: true)
            script << flow_cmd('bundle -v', echo: true)
            script << flow_cmd('bundle install --jobs=3 --retry=3', echo: true, retry: true, timing: true)
            script << flow_cmd('bundle exec rake', echo: true, timing: true)
            script.join("\n")
          end
        end
      end
    end
  end
end

